function showHelpTab(){
    var win = window.open('../animatorFiles/editorHelp/Overview.html', '_blank');
    win.focus();
}
function showToc(txt, title){
    var dialog = $(txt).dialog({
        title: title,
        maxWidth: 400,
        maxHeight: 800,
        width: 250,
        height: 460,
        position: [0,0],
        buttons: {
            Close: function () {
                dialog.dialog("destroy").remove();
            }
        },

    });
}
function getToc(){
    showToc("<div style='font-size:14px;background:#f3eed2'><ul style='list-style-type:none;padding-left:10px'>\
        <li>1.0&nbsp;<a href='Overview.html'>Overview</a></li>\
        <li style='margin-left:15px'>1.1&nbsp;<a style='margin-left:15px' href='QuickStart.html'>Animator Quick Start</a></li>\
        <li style='margin-left:15px'>1.2&nbsp;<a style='margin-left:15px' href='UserInterface.html'>Animator User Interface</a></li>\
        <li>2.0 Load Images</li>\
        <li style='margin-left:15px'>2.1&nbsp;<a style='margin-left:15px' href='LoadImages.html'>Load SVG Images</a></li>\
        <li style='margin-left:15px'>2.2&nbsp;<a style='margin-left:15px' href='ElementTree.html'>Element Tree</a></li>\
        <li style='margin-left:15px'>2.3&nbsp;<a style='margin-left:15px' href='SVGModify.html'>Modify SVG</a></li>\
        <li>3.0 Image Project</li>\
        <li style='margin-left:15px'>3.1&nbsp;<a style='margin-left:15px' href='ActionEvents.html'>Action Events</a></li>\
        <li style='margin-left:15px'>3.2&nbsp;<a style='margin-left:15px' href='ResizeImage.html'>Resize Image</a></li>\
        <li style='margin-left:15px'>3.3&nbsp;<a style='margin-left:15px' href='ExportCopy.html'>Export and Copy Image</a></li>\
        <li>4.0&nbsp;<a href='Transitions.html'>Transitions</a></li>\
        <li style='margin-left:15px'>4.1&nbsp;<a style='margin-left:15px' href='Movements.html'>Move Image</a></li>\
        <li style='margin-left:15px'>4.2&nbsp;<a style='margin-left:15px' href='Scales.html'>Scale Image</a></li>\
        <li style='margin-left:15px'>4.3&nbsp;<a style='margin-left:15px' href='Rotation.html'>Rotate Image</a></li>\
        <li style='margin-left:15px'>4.4&nbsp;<a style='margin-left:15px' href='OnImageEditing.html'>On Image Editing</a></li>\
        <li style='margin-left:15px'>4.5&nbsp;<a style='margin-left:15px' href='Attributes.html'>Image Attributes</a></li>\
        <li style='margin-left:15px'>4.6&nbsp;<a style='margin-left:15px' href='PathTransition.html'>Path Transition</a></li>\
        <li style='margin-left:15px'>4.6&nbsp;<a style='margin-left:15px' href='CurveTransition.html'>Curve Transition</a></li>\
        <li style='margin-left:15px'>4.7&nbsp;<a style='margin-left:15px' href='ClipMaskTransition.html'>Clip/Mask Transition</a></li>\
        <li style='margin-left:15px'>4.8&nbsp;<a style='margin-left:15px' href='MorphTransition.html'>Morph Transition</a></li>\
        <li>5.0&nbsp;<a href='CustomImages.html'>Custom Image</a></li>\
        <li>6.0&nbsp;<a href='Variables.html'>Variables and API</a></li>\
        <li >7.0&nbsp;<a href='DeployImage.html'>Deploy Image</a></li>\
        <li >8.0&nbsp;<a href='TableauExtensions.html'>Tableau Extensions</a></li>\
        <li style='margin-left:15px'>8.1&nbsp;<a style='margin-left:15px' href='TableauExtUsing.html'>Using Extensions</a></li>\
        <li >9.0&nbsp;<a href='PowerBIVisuals.html'>Power BI Visuals</a></li>\
        <li style='margin-left:15px'>9.1&nbsp;<a style='margin-left:15px' href='PowerBIUsing.html'>Using Power BI Visuals</a></li>\
        <li >10.0&nbsp;<a href='Downloads.html'>Downloads</a></li>\
        </ul></div>", "Table of Contents");
     
}
const elementVsData = {
    '_durTxt': 'duration',
    '_delTxt': 'delay',
    '_ease': 'ease',
    '_incMove': 'translate.include',
    '_movementx_mv_type': 'translate.dimx.derive',
    '_movementx_pctbt': 'translate.dimx.percent',
    '_movementx_mv1_txt1':'translate.dimx.value',
    '_movementx_mv2_txt2':'translate.dimx.value',
    '_movementx_rd1_rd1Txt':'translate.dimx.value[0]',
    '_movementx_rd1_rd2Txt':'translate.dimx.value[1]',
    '_movementx_rd2_rd3Txt':'translate.dimx.value[0]',
    '_movementx_rd2_rd4Txt':'translate.dimx.value[1]',


    '_movementy_pctbt': 'translate.dimy.percent',
    '_movementy_mv1_txt1':'translate.dimy.value',
    '_movementy_mv2_txt2':'translate.dimy.value',
    '_movementy_rd1_rd1Txt':'translate.dimy.value[0]',
    '_movementy_rd1_rd2Txt':'translate.dimy.value[1]',
    '_movementy_rd2_rd3Txt':'translate.dimy.value[0]',
    '_movementy_rd2_rd4Txt':'translate.dimy.value[1]',

    '_incScale':'scale.include',
    '_scale_shpt_sc_pt':'scale.shapePoint',
    '_scalex_sc_type': 'scale.pixelSizeX',
    '_scalex_sc1_sc1':'scale.scalex',
    '_scaley_sc1_sc1':'scale.scaley',
    '_scalex_sc2_sc2':'scale.scalex',
    '_scaley_sc2_sc2':'scale.scaley',

    '_incRotate': 'rotate.include',
    '_rotate_shpt_rt_pt':'rotate.shapePoint',
    '_rotate_angle_rtAng':'rotate.angle',


    '_incAttr':'attributes.include',
    '_attr_opacity':'attributes.opacity',
    '_attr_color':'attributes.fill',
    '_attr_stroke':'attributes.stroke',
    '_attr_stroke-width':'attributes.stroke-width',

    '_incPath':'path.include',
    '_pathDatabt':'path.usePathVar',
    '_pathDataVar':'path.pathData',
    '_pathData':'path.pathData',
    '_setupDuration':'path.pathCompletion',
    '_pathCompletion':'path.pathCompletion',
    '_incAdjPath':'path.adjPath.include',
    '_btn_stend':'path.adjPath.type',
    '_path_adj_x_mv_type':'path.adjPath.dimx.derive',
    '_path_adj_x_pctbt':'path.adjPath.dimx.percent',

    '_path_adj_x_mv1_txt1':'path.adjPath.dimx.value',
    '_path_adj_x_mv2_txt2':'path.adjPath.dimx.value',
    '_path_adj_x_rd1_rd1Txt':'path.adjPath.dimx.value[0]',
    '_path_adj_x_rd1_rd2Txt':'path.adjPath.dimx.value[1]',
    '_path_adj_x_rd2_rd3Txt':'path.adjPath.dimx.value[0]',
    '_path_adj_x_rd2_rd4Txt':'path.adjPath.dimx.value[1]',
    '':'',
    '_path_adj_y_pctbt':'path.adjPath.dimy.percent',
    '_path_adj_y_mv1_txt1':'path.adjPath.dimy.value',
    '_path_adj_y_mv2_txt2':'path.adjPath.dimy.value',
    '_path_adj_y_rd1_rd1Txt':'path.adjPath.dimy.value[0]',
    '_path_adj_y_rd1_rd2Txt':'path.adjPath.dimy.value[1]',
    '_path_adj_y_rd2_rd3Txt':'path.adjPath.dimy.value[0]',
    '_path_adj_y_rd2_rd4Txt':'path.adjPath.dimy.value[1]',
    '':'',
    '_incClip':'clip.include',
    '_clipval':'clip.valuePt',
    '_clip_direction':'clip.direction',
    '':'',
    '_incMask':'mask.include',
    '_maskval':'mask.valuePt',
    '_mask_direction':'mask.direction',
    '_maskcolor':'mask.color',

    //curve
    '_curvetype':'translate.curve.type',
    '_numwaves':'translate.curve.numWaves',
    '_waveht':'translate.curve.waveHt',

    //morph
    '_incMorph':'morph.include',
    '_morphData':'morph.morphData',
    '_pathSource':'morph.morphRadio',
    '_morphpath-sel-id':'morph.morphData',
 //   '_morphDataVar':'',
    '_morphVarType': 'morph.varType'
};

//Info Screen values
/**
 * For hyperlinks, there are 3 options. First, use an href with '#' to reference another help page i.e. '#inforDuration' to open that element.
 * Second, to populate the relevant field with a value, use class='popvalue'. This will take the value of the href minus the '#' i.e '#@HOME .
 * Thirdly, a standard URL without a '#' will open a new browser tab with that URL.
 */
const infoScreenData = 
{
    loadImgHd: "Load Project or Image",
    loadImg: "<div class='helpText'>Three options are available. An SVG image or project can be loaded from the local file directory or via a URL link. Additionally, the details of an Inovista Chart can be loaded using a URL link.\
    <ul >\
        <li>\
        To load an SVG image or project from a local file, open ‘Load Image’ then ‘Load from File’. Then click on the ‘Choose File’ button. <br/><br/>\
        <img src='../animatorFiles/editorHelp/images/loadFile.png'/><br/>You can also load an image by clicking on the <img style='width:22px;height:22px' src='../animatorFiles/editorHelp/images/fileopen.svg' /> icon in the toolbar.\
        </li>\
        <li>\
            To load an SVG image or project from a URL, open ‘Load Image’ then ‘Load from URL. Paste or type the URL of the image into the text field and click the arrow. <br/><br/>\
            <img src='../animatorFiles/editorHelp/images/loadURL.png' />\<br/>Clicking on the <b>URL</b> icon in the toolbar will open the URL section.\
        </li>\
        <li>\
            To animate an existing Inovista Chart, open ‘Load Inovista Chart' then ‘Load from URL. Paste or type the URL of the chart into the text field and click the arrow. <br/><br/>\
            <img src='../animatorFiles/editorHelp/images/loadInovistaChart.png' /><br/><br/>\
            For more information on working with Invoista Charts, see <a href='../animatorFiles/editorHelp/LoadImage.html'>Load Image</a>\
        </li>\
    </ul></div>",

    actionEventHd: "Select Event Type",
    actionEvent: "<div class='helpText'>Image animations can be fired/started by a number of different events. To change the current event in the project, select the required event from the combo.\
    Each event can have its own set of animations. When you change the event, a clear animation set will be shown if there are no previous animation definitions or the previously\
    created animation will be loaded. If there are no animations for a specific event type, no animation will happen when that event is fired.<br/><br/>\
    The event options are:<br/>\
    <ul >\
    <li>\
    <b><i>Load/Update</b></i>: The happens when the image is loaded for the first time or when update is called programmatically.\
    </li>\
    <li>\
    <b><i>Click/Tap</b></i>: When the image is clicked or tapped.\
    </li>\
    <li>\
    <b><i>Toggle Click/Tap</b></i>: This happens on all alternate second clicks of the image. The first click will run the 'Click/Tap' option and the second click will run this option.\
    This process is continuous for the life of the image.\
    <li>\
    <b><i>Mouse Over</b></i>: Happens when the user moves the mouse pointer over the image.\
    </li>\
    <li>\
    <b><i>Mouse Out</b></i>: Happens when the user moves the mouse pointer away from the image.\
    </li>\
    </ul>\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ActionEvents.html' target='_blank'>Action Events</a>\
    </div>",


    fireActionEvtHd: "Fire Event",
    fireActionEvt:"<div class='helpText'>If want to use this image with your own javascript code, any of the action events with the exception of 'Update' can be fired when the \
    user initiates the event. Select the checkbox on the relevant event to send the event to a callback function. \
    Each of these events has an option to allow for a programmer to define a callback function to manage that event. Two parameters are passed \
    to the function:<ul><li>svgId - the id of the current images</li><li>elementId - the id of the element in the image that received the event</li></ul>\
    For example, a click can fire the <code>inovistaSvg.setImageToggleClickCallback</code> function. Once set, the event will receive the id of the SVG image and the id of the \
    element in the SVG image that was clicked.<br/>\
    Each event callback function requires the id of the current image and the callback function as a parameter.<br/><br/>The event callback functions to implement are:<br/>\
    <ul><li>For Click:<br/><code>inovistaSvg.setImageClickCallback(svgId, fn)</code</li>\
    <li>For ToggleClick:<br/><code>inovistaSvg.setImageToggleClickCallback(svgId, fn)</code</li>\
    <li>For Mouse Over:<br/><code>inovistaSvg.setImageMouseOverCallback(svgId, fn)</code</li>\
    <li>For Mouse Out:</br><code>inovistaSvg.setImageMouseOutCallback(svgId, fn)</code</li><br/><br/>\
    For Example<br/>\
    <code>\
    inovistaSvg.setImageClickCallback('svg33',<br/>\
    &nbsp;&nbsp;function(svgId, elementId){<br/>\
        &nbsp;&nbsp;&nbsp;&nbsp;console.log('The Id is:' + svgId + ', the elem is: ' + elementId);<br/>\
        &nbsp;&nbsp;});<br/>\
    </code>\
    </ul>\
    </div>",

    rerunActionEvtHd: "Rerun Update",
    rerunActionEvt:"<div class='helpText'>To rerun the animation defined in the 'Load/Update' when the image is clicked or when there is a mouse over, \
    select the 'Rerun Update on Click' or 'Rerun Update on Mouse Over' checkbox.<br/><br/>\
    This functionality is only available when the image has been deployed, it is not available within the Animator.<br/><br/>\
    Note that this option is not available for 'Toggle Click' and 'Mouse Out'.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ActionEvents.html' target='_blank'>Action Events</a>\
    </div>",

    expFilesHd: "Export Project and Animation",
    expFiles: "<div class='helpText'>\
    The current project and the animated image can be exported by selecting the relevant button. <br/><B>N.B.</B>Projects will be renamed ending in '-project.svg' and animated images \
    will be renamed ending in '-anim.svg'. For Inovista Charts and custom images, the '-anim.svg' ending is important. All other files can, of course, be renamed as required.<br/><br/> \
    Options are:<br/>\
    <ul >\
    <li>\
    <b><i>Current Project</b></i>: Exports a saved form of the project in the current state.\
    </li>\
    <li>\
    <b><i>Inovista Chart Image</b></i>: Exports an animated image that can be used and plotted in conjunction with Inovista Charts.\
    </li>\
    <li>\
    <b><i>Stand Alone Image</b></i>: Exports an image that can be copied into a web page or loaded as an 'Object' into the web page. Note that this is an SVG image contained within another SVG image.\
    </li>\
    <li>\
    <b><i>The View Variabale Object Data and Code Snippets</b></i> option presents a copyable data object that can be used in javascript code as well as functions that are available in that code.\
    </li>\
    </ul>\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ExportCopy.html' target='_blank'>Export and Copy</a>\
    </div>",
    
    copyFilesHd: "Copy Project and Animation",
    copyFiles: "<div class='helpText'>\
    The current project and the animated image text can be copied by selecting the relevant button. If you don't have an internet connection, you can copy the text \
    for the images and paste it into a file.<br/><B>N.B.</B>For Inovista Charts and custom images, the '-anim.svg' ending is important. Use a file name ending in '-anim.svg'.<br/><br/> \
    Options are:<br/>\
    <ul >\
    <li>\
    Current Project: Exports a saved form of the project in the current state.\
    </li>\
    <li>\
    Inovista Chart Image: Exports an animated image that can be used and plotted in conjunction with Inovista Charts.\
    </li>\
    <li>\
    Stand Alone Image: Exports an image that can be copied into a web page or loaded as an 'Object' into the web page. Note that this is an SVG image contained within another SVG image.\
    </li>\
    <li>\
    <b><i>The View Variabale Data Objects and Code Snippets</b></i> option presents a copyable data object that can be used in javascript code as well as functions that are available in that code.\
    </li>\
    </ul>\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ExportCopy.html' target='_blank'>Export and Copy</a>\
    </div>",

    elementTreeHd:'The Element Tree',
    elementTree:"<div class='helpText'>\
    The tree contains a list of the valid nodes or elements in the current SVG image.<br/><br/><img src='../animatorFiles/editorHelp/images/svgTree.png' /><br/>The tree has multiple uses.<br/>\
    <ul >\
    <li>\
    Select Element/Node for Transition: To create a transition for the whole image, click on the first element id and then click the 'edit-->' option that becomes visible.\
    This will set the 'Node' select value in 'Transitions'. If this element already contains transitions, they will be loaded. A new transition can be created at anytime\
    by clicking on the '+' icon in the 'Transitions' section. To select an element such as a path in the image, navigate through the tree until the element is found and select it in the same way.\
    </li>\
    <li>\
    Edit Path Visibility and Color: Elements with an edit icon<img src='../animatorFiles/editorHelp/images/editNotePadP.svg' style='width:22px;height:22px;vertical-align:middle' /> are generally paths.\
    Clicking the icon will open a dialog which allows the editing of the element visibility, color/fill, stroke(border) and Dash Array options.\
    </li>\
    <li>\
    Hide Image or Group: Elements with an open or closed eye icon<img src='../animatorFiles/editorHelp/images/eye-blackP.svg' style='width:22px;height:22px;vertical-align:middle' /> are containers\
    which can be shown or hidden by clicking the eye.\
    </li>\
    <br/><b>N.B.</b>Editing of colors and visibility is not currently supported for elements that have pattern or gradient fills.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ElementTree.html' target='_blank'>Element Tree</a>\
    </div>",
    modifySVGHd: 'Modify the Element Content',
    modifySVG: "<div class='helpText'>\
    Clicking on the 'Modify SVG Image' tab will allow elements in the tree to be \
    edited. A red dotted line around the element tree will indicate that the \
    tree is in edit mode. Clicking again will end edit mode.<br>\
    <p>The following aspects of an element in the image can be edited:</p>\
    <ul>\
      <li> <em>Drag/Reorder Elements in Tree</em>: The image elements can be \
        dragged to different locations within the tree. Elements lower down the \
        tree will be displayed above elements above it. Elements can also be \
        dragged into groups and groups can be dragged into other groups.</li> \
      <li> <em>Move/Scale/Rotate</em>: The initial location, scale and rotation \
        can be updated by manipulating a copy of the element placed over the SVG \
        image.</li> \
      <li><em>Change Id</em>: Change to id of an element, typically to make it \
        recognizable when editing.</li> \
      <li><em>Contain in a Group</em>: Add a group to the SVG Image at the \
        current level and place the image within it.</li> \
      <li><em>Reset to Original State</em>: Remove any edits made to the element \
        and revert to its original state. Note that this is only available when \
        an element has been changed.</li> \
      <li><em>Remove Group</em>: Remove the selected Group. Note that this is \
        only available when the group is empty.</li> \
    </ul> \
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/SVGModify.html' target='_blank'>Modify SVG</a>\
    </div>",
    newTransitionHd:'Create/Edit Transitions',
    newTransition:"<div class='helpText'>Transitions can be created for the whole image or for individual elements within the image. If created for the whole image, \
    the image will use the background as a base. Individual elements will use the image as a base. Use the 'Node' dropdown to select either the whole image or an element within it. \
    If a node selection already has transitions, those transitions will be opened by selecting the node.\
    <br/><img style='width:152px; height;30px;vertical-align:middle' src='../animatorFiles/editorHelp/images/transitionElem.png' /><br/>\
    Transitions can be chained, i.e. played one after another. Transitions will be played in the order that they are \
    defined in the 'Transition' section. The transition startup can be delayed by entering a millisecond value in the delay field.<br/><br/>\
    Clicking on the plus icon after 'New Transition' will open a popup and allow the creation of a new transition type. The types are:\
    <ul >\
    <li>\
    <b>Combination</b>: This includes Movements, Scaling, Rotations or Attributes (which allow color, opacity, stroke and dash array options where applicable.\
    </li>\
    <li>\
    <b>Path</b>: This allows the importation of an external path or the use of an internal path(often invisible) to be used as a basis for the movement of the whole image\
    or an element in the image.\
    </li>\
    <li>\
    <b>Curve</b>: This allows the movement along a defined curve or wave.\
    </li>\
    <li>\
    <b>Clip</b>: This allows the creation of an SVG clip which can show/hide various parts of the image or the whole image.\
    </li>\
    <li>\
    <b>Mask</b>: This allows the creation of an SVG mask which can be used to change the color of all or part of an image.\
    </li>\
    <li>\
    <b>Morph Path</b>: This allows the definition of the morphing of a path in the image into another image. The new morph path can be imported\
    into the image or could be a hidden path in the current image.\
    </li></ul>\
    \</div>",
    infoDurationHd: 'Duration',
    infoDuration:
    "<div class='helpText'><P >Duration defines the running time of the transition in milliseconds. If 500 is entered, this means 500 milliseconds or half a second.</p>\
    <p>Text values can also be entered. A text value will be shown in italic blue and will represent a variable. A variable must be set in code at run time programatically.\
    <br/>For more details, see <a href='../animatorFiles/editorHelp/Variables.html' target='_blank'>Application Variables & API</a>\
    </p>\
    <p>Within this app, temporary variables can be entered in the 'Variable Values' section at the bottom of this panel. Enter a data value against the name that you enter here.</div>",

    infoDelayHd: 'Delay',
    infoDelay:
    "<div class='helpText'><P >Delay defines the time in milliseconds before the transition starts. If the delay is in a series of transitions, the delay time will start after the end of the previous transition.\
    For example, if 500 is entered, this means 500 milliseconds or half a second.</p>\
    <p>Text values can also be entered. A text value will be shown in italic blue and will represent a variable. A variable must be set in code at run time programatically.\
    <br/>For more details, see <a href='../animatorFiles/editorHelp/Variables.html' target='_blank'>Application Variables & API</a>\
    </p>\
    <p>Within this app, temporary variables can be entered in the 'Variable Values' section at the bottom of this panel. Enter a data value against the name that you enter here.</div>",
    
    infoEaseHd:'Transition Easing',
    infoEase: "<div class='helpText'>Easing defines the speed of the transition at various points when it is running. It may define acceleration or deceleration at those points.\
    Using easing can help make animation smoother and more realistic.<br/><br/>\
    Select the required easing from the long list in the drop down select. The default option is 'Linear' which means a steady movement with no acceleration or deceleration.\
    Names containing 'in' means emphasis at the beginning of the transition and 'out' with emphasis at the end. 'inOut' means emphasis at both start and end.\
    <br/><br/>Detailed information about each of the options can be found at <a href='https://observablehq.com/@d3/easing'>Easing Graphs</a>\
    </div>",

    infoMoveHd:'Image Movement',
    infoMove: "<div class='helpText'>Images can be moved on the 'x axis' (left -> right) and/or the 'y axis' (up->down).\
    To include movement in this transition, select the 'Include' checkbox. If it is not selected, any movement definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/moveInclude.png' />\
    <br/><br/>If the movement is for the whole image (i.e. the first item in the selection tree), then the movement will be defined for motion of the image within\
    the background.<br/>If a contained element such as a group or a path has been chosen, the motion will be for that group or path within the image itself.\
    <br/>For more details, see <a href='../animatorFiles/editorHelp/Movements.html' target='_blank'>Image Movement</a>\
    </div>",
    infoDragImageHd: 'Edit on Image',
    infoDragImage: "<div class='helpText'>\
    In the Combined and Curve Transitions, the 'Display on Image\
      to Edit' option is available. This allows a user to define the transition\
      for the element or node by dragging it to a new location, by scaling it to\
      a new size or by rotating it to a new angle. <br><br>\
    <b>N.B.</b> For Curve transitions, only movement to a new location is\
    available. Additionally, the option is not available for the whole image\
    only elements within the image. <br><br>\
    For more details, see <a href='../animatorFiles/editorHelp/OnImageEditing.html' target='_blank'>On Image Editing</a>\
    </div>",
    mvdivImgHd:'Move Options',
    mvdivImg: "<div class='helpText'>\
    A number of options are available to move images, select the required option in the dropdown list.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/mvdropdown.png'/>\
    <ul >\
    <li>\
    <b>Move Pixels</b>: Images are moved by the number of pixels or the percent.\
    </li>\
    <li>\
    <b>Goto Pixel</b>: Images are sent to the pixel defined either as a pixel address or the percent across the background.\
    </li>\
    <li>\
    <b>Random Range</b>: Images are sent to a random location between the values entered.\
    </li>\
    <li>\
    <b>Random Or</b>: Images are sent to a random location at one of the two values entered.\
    </li><br/>\
    Images can  be moved or sent to a value based on a percentage or on a pixel number. Click the button\
    to change between 'pixel(px)' and 'percent(%)'.<br/><br/>\
    In any of the options '@HOME' can be entered to send the image to its initial location. Click to populate\
    <a class='popvalue' href='#@HOME'>@HOME</a>\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Movements.html' target='_blank'>Image Movement</a>\
    </div>",

    infoScaleHd:'Image Scale',
    infoScale: "<div class='helpText'>Images can be scaled on the 'x axis' (left -> right) and/or the 'y axis' (up->down).\
    To include a scale in this transition, select the 'Include' checkbox. If it is not selected, any scale definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/scaleinclude.png' />\
    <br/><br/>If the scale is for the whole image (i.e. the first item in the selection tree), then the scale will be defined for motion of the image within\
    the background.<br/>If a contained element such as a group or a path has been chosen, the scale will be for that group or path within the image itself.\
    <br/>For more details, see <a href='../animatorFiles/editorHelp/Scales.html' target='_blank'>Image Scale</a>\
    </div>",

    infoScaleValHd:'Scale Options',
    infoScaleVal: "<div class='helpText'>\
    A number of options are available to scale images. Scaling can be based on a point in the image.\
    Select the required point from the 'Scale on Point' dropdown.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/scalepoints.png'/>\
    <br/><b>Basic Scaling</b><br/>\
    On both the x and y axis, there is the option to scale either by a value, for example selecting '2' will scale \
    the image to double its size or to scale to a specific pixel size.\
    To scale by a value, select 'Scale' in the dropdown next to either and/or the x or y axis option.\
    To scale to a specific pixel size, select 'Scale to Px Size' in the dropdown.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/scalepxsz.png'/>\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Scales.html' target='_blank'>Image Scales</a>\
    </div>",

    infoRotateHd:'Image Rotation',
    infoRotate:  "<div class='helpText'>Images can be rotated in a clockwise or anti-clockwise direction.\
    To include a rotation in this transition, select the 'Include' checkbox. If it is not selected, any rotation definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/rotateInclude.png' />\
    <br/><br/>If the rotation is for the whole image (i.e. the first item in the selection tree), then the rotation will be defined for motion of the image within\
    the background.<br/>If a contained element such as a group or a path has been chosen, the rotation will be for that group or path within the image itself.\
    <br/>For more details, see <a href='../animatorFiles/editorHelp/Rotation.html' target='_blank'>Image Rotation</a>\
    </div>",

    infoRotateValHd:'Rotation Options',
    infoRotateVal: "<div class='helpText'>\
    A number of options are available to scale images. Scaling can be based on a point in the image.\
    Select the required point from the 'Scale on Point' dropdown.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/scalepoints.png'/>\
    <br/><b>Basic Scaling</b><br/>\
    On both the x and y axis, there is the option to scale either by a value, for example selecting '2' will scale \
    the image to double its size or to scale to a specific pixel size.\
    To scale by a value, select 'Scale' in the dropdown next to either and/or the x or y axis option.\
    To scale to a specific pixel size, select 'Scale to Px Size' in the dropdown.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/scalepxsz.png'/>\
    <br/>For more details, see <a href='../animatorFiles/editorHelp/Rotation.html' target='_blank'>Image Rotation</a>\
    </div>",

    infoAttributeHd: 'Attribute Options',
    infoAttribute: "<div class='helpText'>\
    To include attributes in this transition, select the 'Include' checkbox. If it is not selected, any attribute definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/attributeInclude.png' />\
    <br/>Attributes allow transitions to change color, opacity(transparency), stroke values(borders) and in the case of a text element - the text itself. There are also options, where applicable, to create Dash Array transitions. Dash Arrays can be used to present interesting animations, for example that draw a border around an element.\
    The attribute options that are presented depend on the type of element. Group elements will only permit a change in\
    opacity whereas a tspan element will offer a full range of options including the ability to change the text value.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoOpacityAttrHd: "Attribute Opacity",
    infoOpacityAttr: "<div class='helpText'>\
    The opacity(transparency) for the whole element. '1' is completely visible and '0' is invisible. Values between i.e.\
     '0.5' will set the level of transparency.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoColorAttrHd: "Color Fill Attribute",
    infoColorAttr:  "<div class='helpText'>\
    The fill color sets the color inside the element. To set the fill color, use the color button to open a color dialog editor or enter the color in hex format i.e. '#ff0000'.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoFillOpacityAttrHd: "Fill Opacity Attribute",
    infoFillOpacityAttr: "<div class='helpText'>\
    The opacity(transparency) of the inside of the element. '1' is completely visible and '0' is invisible. Values between i.e. '0.5' will set the level of transparency.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoStrokeAttrHd: "Stroke Color",
    infoStrokeAttr: "<div class='helpText'>\
    A stroke is the border of the element. To set the border color, use the color button to open a color dialog editor or enter the color in hex format i.e. '#ff0000'.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoStrokeWdAttrHd: "Stroke Width",
    infoStrokeWdAttr:  "<div class='helpText'>\
    A stroke is the border of the element. This is the width of the stroke(border) in pixels.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoStrokeOpacityAttrHd: "Stroke Opacity",
    infoStrokeOpacityAttr:  "<div class='helpText'>\
    The opacity(transparency) of the border. '1' is completely visible and '0' is invisible. Values between i.e. '0.5' will set the level of transparency.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoStrokeDashAttrHd: "Border Dash Array",
    infoStrokeDashAttr: "<div class='helpText'>\
    Dash Array defines the pattern of dashes and gaps used to paint the outline of the element. For example, '4' alone will set a dashed border with each dash 4 pixels long and a gap of 4 pixels between them. '4 1' will be the same except the gap will be only 1 pixel.\
    <br/><br/><b>N.B.</b>To use this option with a variable, select the 'Array Text is a Variable' checkbox.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoStrokeDashOffsetAttrHd: "Dash Array Offset",
    infoStrokeDashOffsetAttr:  "<div class='helpText'>\
    Dash Offset defines the number of empty pixels before the border begins. A value of '10' will mean the first 10 pixels are empty.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoTextElemAttrHd: "Text Attribute",
    infoTextElemAttr: "<div class='helpText'>\
    The text that is shown for TSPAN elements. If the value is left blank, no changes are made to the text.\
    <br/><br/><b>N.B.</b>To use this option with a variable, select the 'Text is a Variable' checkbox.\
     <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/Attributes.html' target='_blank'>Attributes</a>\
    </div>",

    infoPathHd: "Path Transition",
    infoPath: "<div class='helpText'>\
    To include the path in this transition, select the 'Include' checkbox. If it is not selected, any path definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/pathInclude.png' />\
    <br>An SVG path can be used to move either the whole image or an element in that image. \
    The path can be just about any shape, for example spirals, hexagons or an ad-hoc drawing (but it MUST be a path, rectangles, circles etc. are not supported. \
    These shapes can, of course, be converted to paths in an SVG editor). The image will move along the border of the shape.\
    <br><br>Paths can be based on a path that exists in the image itself, can be pasted in as data or set as a variable.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/PathTransition.html' target='_blank'>Path Transition</a>\
    </div>",

    infoSetupDurationHd: "Path Setup Duration",
    infoSetupDuration: "<div class='helpText'>\
    The Setup Duration is the amount of time taken in milliseconds to move the image to the starting point of the path transition.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/PathTransition.html' target='_blank'>Path Transition</a>\
    </div>",

    infoPathCompletionHd: "Path Completion",
    infoPathCompletion: "<div class='helpText'>\
    The Path Completion is the percentage of the total distance of the path that the transition will move. If the value is '100'\
    the image will move 100% of the length of the path border. If the value is 50%, the image will move half way through the path border.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/PathTransition.html' target='_blank'>Path Transition</a>\
    </div>",

    infoAdjPathHd: "Path Start/End",
    infoAdjPath: "<div class='helpText'>\
    The path motion can begin or end at a specific point in the image. To include a start or end point, select the 'Change Start/End Pt' checkbox.\
    To select 'start' or 'end', click the 'Start/End' button until it shows the required selection.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/pathstendinclude.png' />\
    <br>The movement functionality is exactly the same as how movements are defined in the 'Combination' transition. \
    This includes the ability to use the '@HOME' option.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/PathTransition.html' target='_blank'>Path Transition</a>\
    </div>",
    
    infoClipHd: "Clip Transition",
    infoClip: "<div class='helpText'>\
    To include the clip in this transition, select the 'Include' checkbox. If it is not selected, any clip definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/clipInclude.png' />\
    <br>Enter the percentage of the element to be clipped in the 'Clip %' field. Do not enter a percentage sign. \
    A variable can also be used here so that the amount of clipping can be defined at runtime.\
    <br/><br/>Select the direction of the clip: 'up', 'down', 'left' or 'right'. The clip will be drawn based on the the duration of the transition. To initialize with the clip already drawn, set the duration to '0'.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ClipMaskTransition.html' target='_blank'>Clip Mask Transition</a>\
    </div>",
    
    infoMaskHd: "Mask Transition",
    infoMask: "<div class='helpText'>\
    To include the mask in this transition, select the 'Include' checkbox. If it is not selected, any mask definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/maskInclude.png' />\
    <br>Enter the percentage of the element to be masked in the 'Mask %' field. Do not enter a percentage sign. \
    A variable can also be used here so that the amount of masking can be defined at runtime.\
    <br/><br/>Select the direction of the mask: 'up', 'down', 'left' or 'right'. The mask will be drawn based on the the duration of the transition. To initialize mask the clip already drawn, set the duration to '0'.\
    <br>The color of the mask can be entered in hex format i.e. '#ff0000' or the color popup utility can be used by clicking the icon at the end of the color field. \
    A variable can also be used for the mask color.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/ClipMaskTransition.html' target='_blank'>Clip Mask Transition</a>\
    </div>",

    infoCurveHd: "Curve Transition",
    infoCurve: "<div class='helpText'>\
    To include the curve in this transition, select the 'Include' checkbox next to 'Movement' above. If it is not selected, any curve definitions in this section will be ignored.\
    <br><br>Images can be moved via a semi-circle or a wave motion. The height of the wave(amplitude) and number of waves(frequency) in the motion can be initialized and reset at runtime as a variable if required. \
    The motions are all based on sine waves.\
    <br><br>Select 'Wave', 'Positive Curve' or 'Negative Curve' using the 'Type' dropdown.\
    <br><br>Enter the height or amplitude of the curve or wave in pixels in the  'Wave Ht'  field.  A variable value may also be entered here.\
    <br><br>The 'Num Waves' field defines the number of complete waves a wave transform will undergo (This is ignored for the curve option). A variable may also be entered here.\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/CurveTransition.html' target='_blank'>Curve Transition</a>\
    </div>",
    
    infoMorphValue2Hd: "Morph Transition",
    infoMorphValue2: "<div class='helpText'>\
    To include the morph in this transition, select the 'Include' checkbox. If it is not selected, any morph definitions in this section will be ignored.\
    <br/><br/><img src='../animatorFiles/editorHelp/images/morphInclude.png' />\
    <br>Images of a similar structure can be morphed (or changed) into another through a seamless transition. The morph target image must be a 'Path' element.\
    <br><br>There are 3 ways to select a morph target image:\
    <ul >\
    <li>\
    <b>Select an Existing Path in the Image</b>\
    </li>\
    <li>\
    <b>Paste the Path Data of an Image</b>\
    </li>\
    <li>\
    <b>Enter a Variable Referring to a Path Id or Path Data</b>\
    </li>\
    </ul>\
    <br/><br/>For more details, see <a href='../animatorFiles/editorHelp/MorphTransition.html' target='_blank'>Morph Transition</a>\
    </div>",

    infoCustomRunHd: "Run Custom Transition",
    infoCustomRun: "<div class='helpText'>\
    When a transition for a Custom Image (typically a chart) is created, the 'Run Custom Data Transform' checkbox is available in the Transaction section.<br>\
    Selecting this option means that the image will be populated with its data after this transition has run.<br><br>\
    <b>N.B.</b> The transition does not need to have any activities (i.e. a Movement, Rotation etc.), the chart population will run after the \
    'Delay' and 'Duration' times have elapsed.\
    <br/><br/>For more details about adding and using 'Custom Images', see <a href='../animatorFiles/editorHelp/CustomImages.html' target='_blank'>Custom Images</a>\
    </div>",
    
    infoVarValuesHd: "Variables and Animator API",
    infoVarValues: "<div class='helpText'>\
    Most options in the Animator allow the option of entering a variable name rather than a value. \
    By using a variable, different behaviors can be set at runtime in conjunction with the Animator API. \
    The API allows changes to those variable values using JavaScript functions. These calls can radically change the image animations. \
    It may be as simple as changing the delay or duration of an animation, but it is possible to update most other actions such as the movement direction, \
    the amount of rotation, the x and y dimension scales or in the case of morphing, the target image.\
    <br/><br/>For more details about Variables and using the API, see <a href='../animatorFiles/editorHelp/Variables.html' target='_blank'>Vairables and Animator API</a>\
    </div>",
    
}
const codeSnippets = 
"<p><b>N.B.</b> All function calls need access to the 'inovista.svg.js' file. You will need to add a script link to this file. <br/>e.g "+
"<code>&lt;script src=\"script/inovista.svg.js\"&gt;&lt;/script&gt;</code><br/>" + 
"If you are using the morph option, you will also need to add the morph script<br/>&lt;script src=\"script/d3-path-morphing.js\"&gt;&lt;/script&gt;<br/>" +
"If you are using the Inovista Custom Images or your own customizations, you need to add <br/>&lt;script src=\"script/inovista.customD3.js\"&gt;&lt;/script&gt;<br/>" +
"or your own custom script file.<br/><br/>" +
"<b>Set Image Data</b><br/>" +
"To set the variable data for the image, use <code>'inovistaSvg.setSAImgData'</code> and call it before the image loads.<br/>This function "+
"takes 3 parameters.<br/>1 - the svgid which has been inserted below.<br/>2 - the data object defined above<br/>3 - (optional)the number of times the " +
"animation repeats. Use -1 for continuous, 0 for once or a number of repeat times.<br/><b>N.B.</b>If there are no variables you can still " +
"run this function with an empty data object parameter.<br/><br/>" +
"<input size='50' type='text' value='inovistaSvg.setSAImgData(\"$svgid\", dataObject, repeatTimes)' id='setimgData'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgData\")'>Copy</button><br/><br/>" +

"<b>Refresh and Rerun Image</b><br/>" +
"To run or refresh the image at anytime after loading, use <code>'inovistaSvg.setRefreshSAImgData'</code>.<br/>This function "+
"takes 3 parameters.<br/>1 - the svgid which has been inserted below.<br/>2 - the data object defined above<br/>3 - (optional)the number of times the " +
"animation repeats. Use -1 for continuous, 0 for once or a number of repeat times.<br/><b>N.B.</b>If there are no variables you can still " +
"run this function with an empty data object parameter.<br/><br/>" +
"<input size='56' type='text' value='inovistaSvg.setRefreshSAImgData(\"$svgid\", dataObject, repeatTimes)' id='setimgRefreshData'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgRefreshData\")'>Copy</button><br/><br/>" +

"<b>Reset Image</b><br/>" +
"Resets the image to its original state. This function takes the svgid of the image as a parameter.<br/><br/>" +
"<input size='56' type='text' value='inovistaSvg.resetSAImage(\"$svgid\")' id='setimgRefresh'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgRefresh\")'>Copy</button><br/><br/>" +

"<b>Set Image Data for an Event</b><br/>" +
"Different data can be set for different event types, For events other than 'load/update', use the function below to set the data values.\
To set the variable data for the image, use <code>'inovistaSvg.setSAEventImgData'</code> and call it before the image event takes place.<br/>This function "+
"takes 4 parameters.<br/>1 - the svgid which has been inserted below.<br/>2 - the name of one the non-update events. Valid values are:\
'click', 'clickToggle', 'mouseover', 'mouseout'<br/>3 - the data object defined above<br/>4 - (optional)the number of times the " +
"animation repeats. Use -1 for continuous, 0 for once or a number of repeat times.<br/><b>N.B.</b>If there are no variables you can still " +
"run this function with an empty data object parameter.<br/><br/>" +
"<input size='50' type='text' value='inovistaSvg.setSAEventImgData(\"$svgid\", evt, dataObject, repeatTimes)' id='seteventImgData'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"seteventImgData\")'>Copy</button><br/><br/>" +

"<b>Callback on Completed Animation</b><br/>" +
"The function below will be called once the image animation has completed.<br/>" +
"This function takes 2 parameters.<br/>1 -  the svgid which has been inserted below.<br/>" +
"2 - the function that will be called when the animation completes. The dataObject will be passed to the function as the first parameter.<br/><br/>"+
"<input size='40' type='text' value='inovistaSvg.setTransDoneCallback(\"$svgid\", fn)' id='setimgCallback'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgCallback\")'>Copy</button><br/><br/>" +

"<hr><br/><b>N.B.</b> The following functions must first be activated in the 'Action Event' section under the 'Image Project' section." +
"For each of the event types, there is a 'Fire Event' checkbox. Select this to activate.<br/><br/>" +

"<b>Callback on Click</b><br/>" +
"The function below will be called when the image has been clicked.<br/>" +
"This function takes 2 parameters.<br/>1 -  the svgid which has been inserted below.<br/>" +
"2 - the function that will be called when the image is clicked. <br>Two parameters will be passed to "+
"the function: the image svgId and the Id of the element clicked. Please note that the second parameter will be the " +
"top element if elements under the mouse are stacked.<br/><br/>" +
"<input size='40' type='text' value='inovistaSvg.setImageClickCallback(\"$svgid\", fn)' id='setimgClickCallback'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgClickCallback\")'>Copy</button><br/><br/>" +

"<b>Callback on Toggle Click</b><br/>" +
"The function below will be called when the image has been toggle clicked i.e. clicked a second time.<br/>" +
"This function takes 2 parameters.<br/>1 -  the svgid which has been inserted below.<br/>" +
"2 - the function that will be called when the toggle click occurs.<br/>Two parameters will be passed to "+
"the function: the image svgId and the Id of the element clicked. Please note that the second parameter will be the " +
"top element if elements under the mouse are stacked.<br/><br/>"+
"<input size='40' type='text' value='inovistaSvg.setImageToggleClickCallback(\"$svgid\", fn)' id='setimgToggleClickCallback'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgToggleClickCallback\")'>Copy</button><br/><br/>" +

"<b>Callback on Mouse Over</b><br/>" +
"The function below will be called when the mouse passes over the image.<br/>" +
"This function takes 2 parameters.<br/>1 -  the svgid which has been inserted below.<br/>" +
"2 - the function that will be called when the mouse over occurs.<br/>Two parameters will be passed to "+
"the function: the image svgId and the Id of the element under the mouse. Please note that the second parameter will be the " +
"top element if elements under the mouse are stacked.<br/><br/>" +
"<input size='40' type='text' value='inovistaSvg.setImageMouseOverCallback(\"$svgid\", fn)' id='setimgMouseOverCallback'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgMouseOverCallback\")'>Copy</button><br/><br/>" +

"<b>Callback on Mouse Out</b><br/>" +
"The function below will be called when a mouse mover out of the image.<br/>" +
"This function takes 2 parameters.<br/>1 -  the svgid which has been inserted below.<br/>" +
"2 - the function that will be called when the mouse out occurs. Two parameters will be passed to "+
"the function: the image svgId and the Id of the element under the mouse. Please note that the second parameter will be the " +
"top element if elements under the mouse are stacked.<br/><br/>" +
"<input size='40' type='text' value='inovistaSvg.setImageMouseOutCallback(\"$svgid\", fn)' id='setimgMouseOutCallback'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgMouseOutCallback\")'>Copy</button><br/><br/>" +

"<hr><br/><b>Inovista Chart Data</b><br/>The following method loads data for any Inovista Charts that are contained within the images."+
"This function takes 2 parameters.<br/>1 -  the svgid which has been inserted below.<br/>" +
"2 - the data object used to populate the Inovista Chart. See the Inovista Chart documentation for more details.<br/><br/>" + 
"<input size='40' type='text' value='inovistaSvg.setChartLoadedData(\"$svgid\", fn)' id='setimgChartLoadedData'></input>&nbsp;"+
" <button onclick='copySnippetValue(\"setimgChartLoadedData\")'>Copy</button><br/><br/>" ;






